<template>
    <div class="app-container">
        <div class="filter-container">
            <el-row :gutter="20">
                <el-col :span="16" ref="filter" :model="filter">
                    <el-input prop="keyword" v-model="filter.keyword" ref="keyword" name="keyword" placeholder="Nama tombol panicreport" style="width: 300px;" size="medium" class="filter-item" clearable @keyup.enter.native="handleSearch" @clear="handleSearch"/>
                    <el-button @click="handleSearch" size="mini" type="primary" class="filter-item">
                        <i class="ion-ios-search"></i> Cari
                    </el-button>
                </el-col>
                <el-col :span="8" class="text-align-right">
                    <el-button v-permission="[null, 'panicreport', 'create']" @click="handleCreate" size="mini" type="success">
                        <i class="ion-ios-add-circle"></i> Tambah Laporan Panik
                    </el-button>
                </el-col>
            </el-row>            
        </div>
        <el-table v-loading="tableLoading" :data="panicreports" ref="panicreportTable" style="width: 100%" :height="tableHeight" fit highlight-current-row>
            <el-table-column
                fixed="left"
                label="Tanggal Laporan"
                width="150">
                <template slot-scope="scope">
                    {{ dateFormat(scope.row.updated) }}
                </template>
            </el-table-column>
            <el-table-column                
                label="No. Laporan"
                width="250">
                <template slot-scope="scope">
                    <span style="color:#3E89FA;">{{ scope.row.number }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Pelapor"
                width="200">
                <template slot-scope="scope">
                    <span>{{ scope.row.reporter.profile.fullname }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Tombol Panik"
                width="200">
                <template slot-scope="scope">
                    <span>{{ scope.row.panic.name }}</span>
                </template>
            </el-table-column>  
            <el-table-column
                label="Komentar"
                width="300">
                <template slot-scope="scope">
                    <span>{{ scope.row.note }}</span>
                </template>
            </el-table-column> 
            <el-table-column
                label="Performa"
                width="150">
                <template slot-scope="scope">
                    <el-rate
                        v-model="scope.row.performance"
                        disabled
                        show-score
                        text-color="#ff9900"
                        score-template="{scope.row.performance} points">
                    </el-rate>
                </template>
            </el-table-column> 
            <el-table-column
                label="Status"
                width="150">
                <template slot-scope="scope">
                    <el-tag v-if="scope.row.status == 'done'" type="success" size="mini">Selesai</el-tag>
                    <el-tag v-else-if="scope.row.status == 'onprogress'" type="primary" size="mini">Sedang Ditindaklanjuti</el-tag>
                    <el-tag v-else type="info" size="mini">Menunggu</el-tag>
                </template>
            </el-table-column>
            <el-table-column
                fixed="right"
                label="Tindakan"
                min-width="200">
                <template slot-scope="{row}">
                    <el-button v-permission="[row, 'panicreport', 'viewother']" type="text" @click="handleEdit(row)">Ubah</el-button>
                    <el-button v-permission="[row, 'panicreport', 'deleteother']" type="text" class="text-danger" @click="handleDelete(row)">Hapus</el-button>
                </template>
            </el-table-column>
        </el-table>
        
        <pagination v-show="pagination.pages>1" :total="pagination.total" :page.sync="pagination.page" :perpage.sync="pagination.perpage" @pagination="handleSearch"/>

        <el-dialog v-loading="dialogLoading" :title="dialogTitle[dialogStatus]" :visible.sync="showDialog" width="40%" :show-close="false" @closed="resetForm">
            <el-form ref="panicreportForm" :model="panicreportForm" :rules="panicreportRules">
                <aside>
                    <el-alert type="info" description="Mengatur daftar semua laporan tombol panik untuk masing-masing perumahan." :closable=false show-icon></el-alert>
                </aside>
                <el-form-item label="Warga Perumahan" prop="residential">
                    <el-select 
                        v-model="panicreportForm.residential" 
                        placeholder="Pilih perumahan" 
                        class="width-100" 
                        ref="residential" 
                        name="residential"
                        value-key="id"
                        @change="handleResidentialChange">
                        <el-option
                            v-for="item in residentials"
                            :key="item.id"
                            :label="item.name"
                            :value="item.id">  
                            <span style="float: left">{{ item.name }}</span>
                            <strong style="float: right; color: #8492a6; font-size: 13px">{{ item.administrative_region[0] + ', ' + item.administrative_region[1] + item.administrative_region[2] }}</strong>                                  
                        </el-option>
                    </el-select>
                </el-form-item>
                <el-row :gutter="20">   
                    <el-col :lg="12" :md="24" :sm="24">
                        <el-form-item label="Tombol Panik" prop="panic">
                            <el-select 
                                :disabled="panicreportForm.residential == null"
                                v-model="panicreportForm.panic" 
                                placeholder="Pilih tombol panik" 
                                class="width-100" 
                                ref="panic" 
                                name="panic"
                                value-key="id"
                                @change="handlePanicChange">
                                <el-option
                                    v-for="item in panics"
                                    :key="item.id"
                                    :label="item.name"
                                    :value="item.id">                                
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="Pelapor" prop="reporter">
                            <el-select 
                                :disabled="panicreportForm.residential == null"
                                v-model="panicreportForm.reporter" 
                                placeholder="Ketik nama warga" 
                                class="width-100" 
                                ref="reporter" 
                                name="reporter"
                                clearable
                                filterable
                                remote
                                :remote-method="getUsers"
                                value-key="id"
                                >
                                <el-option
                                    v-for="item in users"
                                    :key="item.id"
                                    :label="item.profile.fullname"
                                    :value="item.id">
                                    <span style="float: left">{{ item.profile.fullname }}</span>
                                    <strong style="float: right; color: #8492a6; font-size: 13px">{{ item.role.name }}</strong>
                                </el-option>
                            </el-select>
                        </el-form-item>                        
                    </el-col>   
                </el-row>              
                <el-row :gutter="20">   
                    <el-col :lg="12" :md="24" :sm="24">
                        <el-form-item label="Respon Tombol Panik" prop="action">
                            <el-select 
                                :disabled="panicreportForm.panic == null"
                                v-model="panicreportForm.action" 
                                placeholder="Pilih respon tombol panik" 
                                class="width-100" 
                                ref="action" 
                                name="action"
                                value-key="id">
                                <el-option
                                    v-for="item in actions"
                                    :key="item.id"
                                    :label="capitalize(item.action)"
                                    :value="item.id">                                
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="12" :md="24" :sm="24">
                        <el-form-item label="Status" prop="status">
                            <el-select 
                                v-model="panicreportForm.status" 
                                placeholder="Pilih status" 
                                class="width-100" 
                                ref="status" 
                                name="status">
                                <el-option
                                    v-for="item in status"
                                    :key="item.value"
                                    :label="item.label"
                                    :value="item.value">                                
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>                       
                </el-row>
                <el-row :gutter="20">
                    <el-col :lg="16" :md="24" :xs="24">
                        <el-form-item label="Komentar" :prop="panicreportForm.note">
                            <el-input ref="note" name="note" v-model="panicreportForm.note" placeholder="Masukkan komentar" autocomplete="off" maxlength="255" show-word-limit></el-input>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="8" :md="24" :xs="24">
                        <el-form-item label="Performa" prop="performance">
                            <el-rate v-model="panicreportForm.performance"></el-rate>
                        </el-form-item>
                    </el-col>
                </el-row>                
                <br>
                <el-form-item label="Performa" prop="coordinate">
                <GmapMap 
                    id="map"
                    ref="mapRef"
                    :options="{
                        zoomControl: true,
                        mapTypeControl: false,
                        scaleControl: false,
                        streetViewControl: false,
                        rotateControl: false,
                        fullscreenControl: true,
                        disableDefaultUi: false
                    }"
                    :zoom="map.zoom"
                    :center="map.center">
                    <GmapMarker ref="markerRef" :position="map.center" :draggable="true" @dragend="handleMoveMarker($event)"/>
                </GmapMap>
                </el-form-item>  
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="showDialog = false" size="medium">Batal</el-button>
                <el-button v-permission="[null, 'panicreport', 'editown']" @click="handleSubmit" size="mini" type="success">
                    <i class="ion-ios-checkmark-circle"></i> {{ dialogTitle[dialogStatus] }}
                </el-button>
            </span>
        </el-dialog>

    </div>
</template>
<script>
import {gmapApi} from 'vue2-google-maps';
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import Pagination from '@/components/Pagination';
import { parseError, playSound, dateFormat, tableHeight, capitalize } from '@/utils/index';
import { setTimeout } from 'timers';

export default {
    name: 'PanicReport',
    components: {
        Pagination
    },
    directives: {
        permission
    },
    data(){

        var validateRestrictedMap = (rule, value, callback) => {
            if(this.panicreportForm.latitude == null || this.panicreportForm.longitude == null){
                return callback(new Error('Lokasi laporan panik wajib dipilih'));
            }else if(this.panicreportForm.residential == null){
                return callback(new Error('Perumahan wajib dipilih'));
            }

            callback();
        };

        var validateNote = (rule, value, callback) => {
            if(this.panicreportForm.status == 'done' && value.trim().length == 0){
                return callback(new Error('Komentar wajib diisi'))
            }
            callback();
        };

        var validatePerformance = (rule, value, callback) => {
            if(this.panicreportForm.status == 'done' && this.panicreportForm.performance == 0){
                return callback(new Error('Performa wajib diisi'))
            }
            callback();
        };

        return {
            tableLoading: false,
            dialogLoading: false,
            filter: {
                keyword: '',
                residential: null,
                panic: null,
                action: null         
            },
            showDialog: false,
            showFilterDialog: false,
            dialogStatus: '',
            dialogTitle: {
                edit: 'Ubah Laporan Panik',
                create: 'Tambah Tombol Panik'
            },
            map: {
                zoom: 14,
                center: {
                    lat: -2.9760735,
                    lng: 104.77543070000002
                }
            },
            selectedResidential: null,
            actions: [],
            status: [{
                label: 'Menunggu Petugas',
                value: 'waiting'
            }, {
                label: 'Sedang Ditindaklanjuti',
                value: 'onprogress'
            }, {
                label: 'Selesai',
                value: 'done'
            }],
            panicreportForm: {
                id: null,
                latitude: null,
                longitude: null,
                performance: 0,
                reporter: null,
                panic: null,
                residential: null,
                note: '',
                status: null,
                archived: false
            },
            panicreportRules: {
                panic: [{
                    required: true, message: 'Tombol panik wajib dipilih', trigger: 'change'
                }],
                reporter: [{
                    required: true, message: 'Pelapor wajib dipilih', trigger: 'change'
                }],
                residential: [{
                    required: true, message: 'Warga perumahan wajib dipilih', trigger: 'change'
                }],
                status: [{
                    required: true, message: 'Status wajib dipilih', trigger: 'change'
                }],
                coordinate: [{
                    validator: validateRestrictedMap, trigger: 'change'
                }],
                note: [{
                    validator: validateNote, trigger: 'change'
                }],
                performance: [{
                    validator: validatePerformance, trigger: 'change'
                }]
            },
        };
    },
    computed: {
        tableHeight,
        ...mapGetters('auth', ['token']),
        ...mapGetters('user', ['me', 'users']),
        ...mapGetters('residential', ['residentials']),
        ...mapGetters('panic', ['panics']),
        ...mapGetters('panicreport', [
            'panicreports',
            'pagination'
        ]),
    },
    created() {
        this.getPanicReports();
        this.getResidentials();
    },
    methods: {
        playSound,
        dateFormat,
        capitalize,
        google: gmapApi,
        getPanicReports() {
            this.tableLoading = true;
            this.$store.dispatch('panicreport/getPanicReports', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        getResidentials() {
            this.tableLoading = true;
            this.$store.dispatch('residential/getResidentials', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;                
            });
        },
        getPanics() {
            this.tableLoading = true;
            this.$store.dispatch('panic/getPanics', {
                residential: this.panicreportForm.residential,
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;                
            });
        },
        getUsers() {
            this.tableLoading = true;
            this.$store.dispatch('user/getUsers', {
                residential: this.panicreportForm.residential,
                page: this.pagination.page,
                perpage: 100
            }).then(() => {
                this.tableLoading = false;
            });
        },
        handleSearch(){

            this.showFilterDialog = false;

            let payload = {
                q: this.filter.keyword,
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }

            if(this.filter.residential != null){
                payload['residential'] = this.filter.residential;
            }

            if(this.filter.reporter != null){
                payload['reporter'] = this.filter.reporter;
            }

            if(this.filter.panic != null){
                payload['panic'] = this.filter.panic;
            }

            this.tableLoading = true;
            this.$store.dispatch('panicreport/getPanicReports', payload).then(() => {
                this.tableLoading = false;
            });
        },
        handleResidentialChange(value){
            this.getPanics();
            this.getUsers();

            for(const x of this.residentials){
                if(x.id == value){
                    this.selectedResidential = x;
                }
            }
        },
        handlePanicChange(value){
            if(value){
                for(const x of this.panics){
                    if(x.id == value){
                        this.actions = x.actions;
                    }
                }
            }
        },
        handleMoveMarker(e){
            this.panicreportForm.latitude = e.latLng.lat();
            this.panicreportForm.longitude = e.latLng.lng();

            var self = this;

            setTimeout(() => {
                self.$refs.mapRef.$mapPromise.then((map) => {
                    map.setZoom(18);
                    map.panTo({lat: e.latLng.lat(), lng: e.latLng.lng()});
                });
            }, 500);
        },
        handleRestrictedArea(){           

            var x = this.panicreportForm.latitude, 
                y = this.panicreportForm.longitude,
                polyPoints = JSON.parse(this.selectedResidential.polygon),
                inside = false,
                intersections = 0,
                ss ='';

            for (var i = 0, j = polyPoints.length - 1; i < polyPoints.length; j = i++) {
                var xi = polyPoints[i].lat, yi = polyPoints[i].lng; var xj = polyPoints[j].lat, yj = polyPoints[j].lng;

                if (yj == yi && yj == y && x > Math.min(xj, xi) && x < Math.max(xj, xi)) {
                    return true;
                }

                if (y > Math.min(yj, yi) && y <= Math.max(yj, yi) && x <= Math.max(xj, xi) && yj != yi) {
                    ss = (y - yj) * (xi - xj) / (yi - yj) + xj;

                    if (ss == x) {
                        return true;
                    }

                    if (xj == xi || x <= ss) {
                        intersections++; 
                    } 
                } 
            }

            if (intersections % 2 != 0) {
                return true;
            } else {
                return false;
            }
        },
        handleCreate(){
            this.dialogStatus = 'create';
            this.showDialog = true;          
            this.$nextTick(() => {
                this.$refs['panicreportForm'].clearValidate();
            });
        },
        handleEdit(panicreport){
            this.dialogStatus = 'edit';
            this.showDialog = true;   
            this.panicreportForm.id = panicreport.id;
            this.panicreportForm.action = panicreport.action.id;
            this.panicreportForm.panic = panicreport.panic.id;
            this.panicreportForm.performance = panicreport.performance;
            this.panicreportForm.residential = panicreport.residential.id;
            this.panicreportForm.reporter = panicreport.reporter.id;            
            this.panicreportForm.archived = panicreport.archived;
            this.panicreportForm.latitude = panicreport.latitude;
            this.panicreportForm.longitude = panicreport.longitude;
            this.panicreportForm.status = panicreport.status;
            this.panicreportForm.note = panicreport.note;

            this.selectedResidential = panicreport.residential;

            this.getPanics();
            this.getUsers(panicreport.reporter.profile.fullname);
            
            setTimeout(() => {
                for(const x of this.panics){
                    if(x.id == panicreport.panic.id){
                        this.actions = x.actions;
                    }
                }
            }, 100);

            this.map.center.lat = panicreport.latitude;
            this.map.center.lng = panicreport.longitude;

            var self = this;

            setTimeout(() => {
                self.$refs.mapRef.$mapPromise.then((map) => {
                    map.setZoom(18);
                    map.panTo(self.map.center);
                });
            }, 100);

            this.$nextTick(() => {
                this.$refs['panicreportForm'].clearValidate()
            });     
        },
        handleSubmit(){
            this.$refs.panicreportForm.validate((valid) => {

                if(!this.handleRestrictedArea()){
                    valid = false;
                    this.$message.error({
                        message: 'Maaf lokasi anda diluar jangkauan.'
                    });
                    this.playSound();
                }

                if(valid){

                    let action = '';
                    let payload = {};

                    this.dialogLoading = true;

                    if(this.dialogStatus == 'create'){
                        action = 'panicreport/addPanicReport';
                        payload = {
                            action: this.panicreportForm.action,
                            panic: this.panicreportForm.panic,
                            performance: this.panicreportForm.performance,
                            residential: this.panicreportForm.residential,
                            reporter: this.panicreportForm.reporter,
                            latitude: this.panicreportForm.latitude,
                            longitude: this.panicreportForm.longitude,
                            status: this.panicreportForm.status,
                            note: this.panicreportForm.note
                        };
                    }else if(this.dialogStatus == 'edit'){
                        action = 'panicreport/editPanicReport';
                        payload = {
                            id: this.panicreportForm.id,
                            action: this.panicreportForm.action,
                            panic: this.panicreportForm.panic,
                            performance: this.panicreportForm.performance,
                            residential: this.panicreportForm.residential,
                            reporter: this.panicreportForm.reporter,
                            latitude: this.panicreportForm.latitude,
                            longitude: this.panicreportForm.longitude,
                            archived: this.panicreportForm.archived,
                            status: this.panicreportForm.status,
                            note: this.panicreportForm.note                       
                        };
                    }

                    this.$store.dispatch(action, payload).then((response) => {
                        this.dialogLoading = false;

                        if('errors' in response){
                            let error = parseError(response.errors);
                            this.$message.error({
                                message: error.messages
                            });
                        }else{
                            this.showDialog = false;
                            this.$message.success({
                                message: response.message
                            });
                            this.resetForm();
                        }

                        this.playSound();

                    });

                }else{                    
                    return false;
                }
            });
        },
        handleDelete(panicreport){
            this.$confirm('Anda mencoba untuk menghapus data laporan tombol panik, data tidak bisa dikembalikan setelah dihapus. Anda yakin?', 'Peringatan', {
                confirmButtonText: 'Ya, Hapus',
                cancelButtonText: 'Batal'
            }).then(() => {
                this.tableLoading = true;
                this.$store.dispatch('panicreport/deletePanicReport', {
                    id: panicreport.id
                }).then((response) => {
                    this.tableLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        this.$message.error({
                            message: error.messages
                        });
                    }else{
                        this.showDialog = false;
                        this.$message.success({
                            message: response.message
                        });
                    }

                    this.playSound();
                });
            });
        },
        resetForm() {
            this.panicreportForm = {
                id: null,
                latitude: null,
                longitude: null,
                performance: 0,
                reporter: null,
                panic: null,
                residential: null,
                note: '',
                status: null,
                archived: false
            };
        }
    }

}
</script>
<style>
    #map{
        width: 100%;
        height: 400px;
    }
</style>